//
//  CCSpriteGif.m
//  
//
//  Created by Yuming on 13-1-23.
//  Copyright 2013年 __MyCompanyName__. All rights reserved.
//

#import "CCSpriteGif.h"

@implementation CCSpriteGif
@synthesize playTime = m_playTime;

- (id)initWithGifFile:(NSString*)path andPlayCount:(unsigned int)count andInterval:(float)interval andDelay:(ccTime)delay andStartIndex:(unsigned int)startIndex{
    if (self = [super init]) {
        NSDictionary* gifLoopCount = [NSDictionary dictionaryWithObject:[NSNumber numberWithInt:0] forKey:(NSString *)kCGImagePropertyGIFLoopCount];
        
        m_gifProperties = [[NSDictionary dictionaryWithObject:gifLoopCount forKey:(NSString *)kCGImagePropertyGIFDictionary] retain];
        
        m_gifSourceRef = CGImageSourceCreateWithURL((CFURLRef)[NSURL fileURLWithPath:path], (CFDictionaryRef)m_gifProperties);
        
        m_loopCount = CGImageSourceGetCount(m_gifSourceRef);

        [self replayGifCount:count andInterval:interval andDelay:delay andStartIndex:startIndex];
    }
    return self;
}

- (id)initWithGifFile:(NSString*)path andPlayTime:(float)playTime andInterval:(float)interval andDelay:(ccTime)delay andStartIndex:(unsigned int)startIndex {
    if (self = [super init]) {
        NSDictionary* gifLoopCount = [NSDictionary dictionaryWithObject:[NSNumber numberWithInt:0] forKey:(NSString *)kCGImagePropertyGIFLoopCount];
        
        m_gifProperties = [[NSDictionary dictionaryWithObject:gifLoopCount forKey:(NSString *)kCGImagePropertyGIFDictionary] retain];
        
        m_gifSourceRef = CGImageSourceCreateWithURL((CFURLRef)[NSURL fileURLWithPath:path], (CFDictionaryRef)m_gifProperties);
        
        m_loopCount = CGImageSourceGetCount(m_gifSourceRef);
        
        m_playTime = playTime;
        
        NSAssert(interval > 0, @"interval must more than 0!");
        [self replayGifCount:(m_playTime / interval) / m_loopCount andInterval:interval andDelay:delay andStartIndex:startIndex];
    }
    return self;
}

- (void)dealloc {
    [self unschedule:@selector(playStart:)];
    CFRelease(m_gifSourceRef);
    [m_gifProperties release];
    [super dealloc];
}

- (void)playStart:(ccTime)ti {
    m_startIndex = (++m_startIndex) % m_loopCount;
    CGImageRef ref = CGImageSourceCreateImageAtIndex(m_gifSourceRef, m_startIndex, (CFDictionaryRef)m_gifProperties);
    [self setDisplayFrame:[[CCSprite spriteWithCGImage:ref key:nil] displayFrame]];
}

- (void)replayGifCount:(unsigned int)count andInterval:(float)interval andDelay:(ccTime)delay andStartIndex:(unsigned int)startIndex {
    m_startIndex = startIndex;
    m_playTime = m_loopCount * count * interval;
    [self schedule:@selector(playStart:) interval:interval repeat:m_loopCount * count delay:delay]; 
}

- (void)stopGif {
    m_startIndex = 0;
    m_playTime = 0;
    [self unschedule:@selector(playStart:)];
}

@end
